'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * 小于10的数字前面加0
 */
var prefixZero = exports.prefixZero = function prefixZero(num) {
	if (num < 10 && num > 0) {
		return "0" + num;
	} else if (num <= 0) {
		return '00';
	}
	return num;
};
/**
 * [description]
 */
var def = exports.def = function def(obj, key, val, enumerable) {
	Object.defineProperty(obj, key, {
		value: val,
		enumerable: !!enumerable,
		writable: true,
		configurable: true
	});
};

var isObj = exports.isObj = function isObj(target) {
	return (typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object';
};

/**
 * 判断是否存在
 */
var hasOwn = exports.hasOwn = function hasOwn(target, key) {
	return Object.prototype.hasOwnProperty.call(target, key);
};

/**
 * 深拷贝
 */
var baseClone = function baseClone(target, source) {
	for (var k in source) {
		// 只拷贝实例属性，不进行原型的拷贝
		if (hasOwn(source, k)) {
			// 引用类型的数据单独处理
			if (_typeof(source[k]) == 'object') {
				target[k] = Array.isArray(source[k]) ? [] : {};
				// 递归处理引用类型数据(利用引用处理)
				baseClone(target[k], source[k]);
			} else {
				// 值类型的数据直接进行拷贝
				target[k] = source[k];
			}
		}
	}
	return target;
};
var cloneDeep = exports.cloneDeep = function cloneDeep(source) {
	return baseClone(Array.isArray(source) ? [] : {}, source);
};
var cloneDeepEasier = exports.cloneDeepEasier = function cloneDeepEasier(source) {
	return JSON.parse(JSON.stringify(source));
};