"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 浮点数计算 加法
 * @param arg1
 * @param arg2
 * @returns {number}
 */
var accAdd = exports.accAdd = function accAdd(arg1, arg2) {
	var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	var r1 = void 0,
	    r2 = void 0,
	    m = void 0,
	    c = void 0;
	try {
		r1 = arg1.toString().split(".")[1].length;
	} catch (e) {
		r1 = 0;
	}
	try {
		r2 = arg2.toString().split(".")[1].length;
	} catch (e) {
		r2 = 0;
	}
	c = Math.abs(r1 - r2);
	m = Math.pow(10, Math.max(r1, r2));
	if (c > 0) {
		var cm = Math.pow(10, c);
		if (r1 > r2) {
			arg1 = Number(arg1.toString().replace(".", ""));
			arg2 = Number(arg2.toString().replace(".", "")) * cm;
		} else {
			arg1 = Number(arg1.toString().replace(".", "")) * cm;
			arg2 = Number(arg2.toString().replace(".", ""));
		}
	} else {
		arg1 = Number(arg1.toString().replace(".", ""));
		arg2 = Number(arg2.toString().replace(".", ""));
	}
	return (arg1 + arg2) / m;
};

/**
 * 浮点数计算 减法
 * @param arg1
 * @param arg2
 * @returns {string}
 */
var accSub = exports.accSub = function accSub(arg1, arg2) {
	var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	var r1 = void 0,
	    r2 = void 0,
	    m = void 0,
	    n = void 0;
	try {
		r1 = arg1.toString().split(".")[1].length;
	} catch (e) {
		r1 = 0;
	}
	try {
		r2 = arg2.toString().split(".")[1].length;
	} catch (e) {
		r2 = 0;
	}
	m = Math.pow(10, Math.max(r1, r2));
	n = r1 >= r2 ? r1 : r2;
	return ((arg1 * m - arg2 * m) / m).toFixed(n);
};
/**
 * 浮点数计算 乘法
 * @param arg1
 * @param arg2
 * @returns {number}
 */
var accMul = exports.accMul = function accMul(arg1, arg2) {
	var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	var m = 0,
	    s1 = arg1.toString(),
	    s2 = arg2.toString();
	try {
		m += s1.split(".")[1].length;
	} catch (e) {}
	try {
		m += s2.split(".")[1].length;
	} catch (e) {}
	return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
};
/**
 * 浮点数计算 除法
 * @param arg1
 * @param arg2
 * @returns {number}
 */
var accDiv = exports.accDiv = function accDiv(arg1, arg2) {
	var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	var t1 = 0,
	    t2 = 0,
	    r1 = void 0,
	    r2 = void 0;
	try {
		t1 = arg1.toString().split(".")[1].length;
	} catch (e) {}
	try {
		t2 = arg2.toString().split(".")[1].length;
	} catch (e) {}

	r1 = Number(arg1.toString().replace(".", ""));
	r2 = Number(arg2.toString().replace(".", ""));
	return r1 / r2 * Math.pow(10, t2 - t1);
};
/**
 * 针对以上加减乘除
 * 支持链式调用
 * Acc(a).add(1).add(2)
 * class -> babel 
 */

var acc = exports.acc = function acc(value) {
	var Acc = function () {
		function Acc(val) {
			_classCallCheck(this, Acc);

			this.result = val;
		}

		_createClass(Acc, [{
			key: "add",
			value: function add(val) {
				this.result = accAdd(this.result, val);
				return this;
			}
		}, {
			key: "sub",
			value: function sub(val, isExchange) {
				this.result = isExchange ? accSub(this.result, val) : accSub(val, this.result);
				return this;
			}
		}, {
			key: "mul",
			value: function mul(val) {
				this.result = accMul(this.result, val);
				return this;
			}
		}, {
			key: "div",
			value: function div(val, isExchange) {
				this.result = isExchange ? accDiv(this.result, val) : accDiv(val, this.result);
				return this;
			}
		}, {
			key: "val",
			value: function val() {
				var _value = this.result;
				if ((typeof _value === "undefined" ? "undefined" : _typeof(_value)) === 'object') {
					throw new TypeError('参数错误');
					return 0;
				}
				return _value || 0;
			}
		}]);

		return Acc;
	}();

	return new Acc(value);
};