"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 原型合并或者多(合并)继承
 */
var copyProperties = function copyProperties(target, source) {
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = Reflect.ownKeys(source)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var key = _step.value;

			if (key !== "constructor" && key !== "prototype" && key !== "name") {
				var desc = Object.getOwnPropertyDescriptor(source, key);
				Object.defineProperty(target, key, desc);
			}
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}
};
// 用于class
// class xxx extends mixins(a, b, c) {}
var mixins = exports.mixins = function mixins() {
	for (var _len = arguments.length, _mixins = Array(_len), _key = 0; _key < _len; _key++) {
		_mixins[_key] = arguments[_key];
	}

	var Mix = function Mix() {
		_classCallCheck(this, Mix);
	};

	var _iteratorNormalCompletion2 = true;
	var _didIteratorError2 = false;
	var _iteratorError2 = undefined;

	try {

		for (var _iterator2 = _mixins[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
			var mixin = _step2.value;

			copyProperties(Mix, mixin); // 拷贝实例属性
			copyProperties(Mix.prototype, mixin.prototype); // 拷贝原型属性
		}
	} catch (err) {
		_didIteratorError2 = true;
		_iteratorError2 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion2 && _iterator2.return) {
				_iterator2.return();
			}
		} finally {
			if (_didIteratorError2) {
				throw _iteratorError2;
			}
		}
	}

	return Mix;
};
// 用于对象 
// @createMixins({})
// class {}
var createMixins = exports.createMixins = function createMixins() {
	for (var _len2 = arguments.length, mixins = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		mixins[_key2] = arguments[_key2];
	}

	return function (target) {
		Object.assign.apply(Object, [target.prototype].concat(mixins));
	};
};