'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
/**
 * canvas
 */
var canvas2file = exports.canvas2file = function canvas2file(canvas) {
	var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	var _opts$fileName = opts.fileName,
	    fileName = _opts$fileName === undefined ? '____fileName' : _opts$fileName,
	    _opts$getFile = opts.getFile,
	    getFile = _opts$getFile === undefined ? false : _opts$getFile;

	// As base64

	var base64Image = canvas.toDataURL("image/png");
	// As a blob 移动端不兼容
	return new Promise(function (resolve, reject) {
		var file = void 0;
		if (getFile) {
			var arr = base64Image.split(',');
			var mime = arr[0].match(/:(.*?);/)[1];
			var bstr = atob(arr[1]);
			var n = bstr.length;
			var u8arr = new Uint8Array(n);
			while (n--) {
				u8arr[n] = bstr.charCodeAt(n);
			}
			file = new Blob([u8arr], { type: mime });
			file.name = fileName;
		}
		resolve({ file: file, base64Image: base64Image });
	});
};

/**
 * 用word方式计算正文字数
 * @param str 
 */
var getWordsLength = exports.getWordsLength = function getWordsLength(str) {
	var sLen = 0;
	try {
		// 先将回车换行符做特殊处理
		str = str.replace(/(\r\n+|\s+|　+)/g, "龘");
		// 处理英文字符数字，连续字母、数字、英文符号视为一个单词
		str = str.replace(/[\x00-\xff]/g, "m");
		// 合并字符m，连续字母、数字、英文符号视为一个单词
		str = str.replace(/m+/g, "*");
		// 去掉回车换行符
		str = str.replace(/龘+/g, "");
		// 返回字数
		sLen = str.length;
	} catch (e) {}
	return sLen;
};